/****************************************************************************/
/** G-FIT V1.0                                                             **/
/** Fitting hyper-Erlang distributions to trace data with the EM algorithm **/
/**                                                                        **/
/** Developed by Axel Thuemmler, July/August 2004                          **/
/** Copyright (c) 2004 University of Dortmund. All rights reserved.        **/
/**                                                                        **/
/** The G-FIT software package is distributed in open-source under the     **/
/** terms of the GNU general public license agreement. To document the     **/
/** usage of G-FIT, we ask each user to cite our scientific publications   **/
/** mentioned on our Web site.                                             **/
/****************************************************************************/
#ifndef QUEUE_H
#define QUEUE_H

#include "gerlangdist.h"


typedef struct tagTGED
{
	double loglikelihood;
	unsigned int m;
	unsigned int* r;
	double* lambdas;
	double* weights;
} TGED;


//---------------------
// Definition of class
//---------------------
class TQueue
{

	public:

		// Constructor
		TQueue(unsigned int _size, unsigned int m_max);

		// Destructor
		~TQueue();

		void insert(TGED ged);

		void update(unsigned int pos, double llh, double* lambdas, double* weights);

		void get(unsigned int pos, TGerlangDist* gdist);

		void get_bestfit(TGerlangDist* gdist);

		unsigned int get_size();

		void print(unsigned int num);

	private:

		void insert_pos(unsigned int pos, TGED ged);

		unsigned int size;

		unsigned int num_in;

		TGED** queue;

};

#endif
